package net.knarcraft.ffmpegconverter.streams;

/**
 * An object representation of a stream in a media file
 */
public abstract class StreamObject {
    int absoluteIndex;
    int relativeIndex;
    String codecName;
    String codecType;

    /**
     * Gets the type of the stream codec (video/audio/subtitle)
     * @return codec type
     */
    public String getCodecType() {
        return this.codecType;
    }

    /**
     * Gets the name of the stream codec
     * @return codec name
     */
    public String getCodecName() {
        return this.codecName;
    }

    /**
     * Gets the absolute index of a stream object
     * @return absolute index
     */
    public int getAbsoluteIndex() {
        return this.absoluteIndex;
    }

    /**
     * Gets the relative index of a stream object (kth element of codec type)
     * @return relative index
     */
    public int getRelativeIndex() {
        return this.relativeIndex;
    }
}